#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include <math.h>  
#include <fstream.h>    
#include "Element.h"
#include "Ancre.h"
#include "Clone.h"
#include "Carte.h"

//--------------------declaration des fonctions appelees-------------------
void main_lecture(char* ficclone, char * ficancre);
void main_simul(char* fic);

//-------------------variable globale--------------------------------------
int     french=0; // par defaut: messages en anglais

//-------------------Ecriture du message signalant une erreur de syntaxe----

void erreur()
{
if (french==1)
  {
	cerr 
    <<"Syntaxe quand les positions des clones et des ancres sont entres :" 
    << endl
    <<  "   " 
    << "island"
    <<" -c[lones] nom-fichier-des-clones -a[nchors] nom-fichier-des-ancres [-f[rench] " 
     << endl << endl
     << "Syntaxe quand les positions des clones et des ancres sont simules :"
     << endl
     << "   " 
     <<"island"
     <<" [-d[etail] nom-fichier-sortie] [-f[rench]]"
     << endl  <<  endl;
	    
  }
else
  {
	cerr 
    <<"Usage when anchor and clone locations are in input:" << endl
    <<  "   " 
    << "island"
    <<" -c[lones] file-for-clones -a[nchors] file-for-anchors [-f[rench] " 
    << endl << endl
    << "Usage when anchor and clone locations are simulated: " << endl
    << "   " 
    <<"island"
    <<" [-d[etail] output-file] [-f[rench]]"
    << endl  <<  endl;
  } // fin cas anglais

} // FIN programme erreur


//-------------------PROGRAMME PRINCIPAL -------------------------------
                       
int main(int argc, char *argv[])
{
  //---------------------declaration des variables-----------------------------

         char   *fic=NULL;        //nom du fichier detail (cas simulation)
         char   *ficclone=NULL;   //nom du fichier des positions des clones
         char   *ficancre=NULL;   //nom du fichier des positions des ancres

         int     num_arg=1;
	 int     error=0;        // indicateur d'erreur de syntaxe

  //---------------------decodage des arguments--------------------------------

  if ((argc>=1) && (argc<=3)) 
    {
      //-----------------Cas simulation
	while (num_arg < argc)
	  {    
	    if ( strncmp(argv[num_arg],"-d", 2)==0)
		{
		  num_arg++;
		  fic = new char[strlen(argv[num_arg])+1];
		  strcpy(fic,argv[num_arg]);
		  num_arg++;
		  continue;
		}
	    if (strncmp(argv[num_arg],"-f", 2)==0)
		{
		  french=1;
		  num_arg++;
		  continue;
		}
	    if ( (strncmp(argv[num_arg],"-d", 2)!=0) &&
		 (strncmp(argv[num_arg],"-f", 2) !=0))
	      {
		//		erreur();
		// exit(1);
		error=1;
		num_arg++;
		continue;

	      }  
	  } // fin while (num_arg < argc)
	if (error == 1 )
	  {
	    erreur();
	    exit(1);
	  }
		  
          main_simul(fic);
    } // fin Cas simulation

  else
    {
    if ((argc==5) || (argc==6))
      { 
      //-----------------Cas lecture
	while (num_arg < argc)
	  {    
	    if ( strncmp(argv[num_arg],"-c", 2)==0)
		{
		  num_arg++;
		  ficclone = new char[strlen(argv[num_arg])+1];
		  strcpy(ficclone,argv[num_arg]);
		  num_arg++;
		  continue;
		}
	    if (strncmp(argv[num_arg],"-a", 2)==0)
		{
		  num_arg++;
		  ficancre = new char[strlen(argv[num_arg])+1];
		  strcpy(ficancre,argv[num_arg]);
		  num_arg++;
		  continue;
		}
	    if (strncmp(argv[num_arg],"-f", 2)==0)
		{
		  french=1;
		  num_arg++;
		  continue;
		}
		  
	    if ( (strncmp(argv[num_arg],"-c", 2)!=0) &&
		 (strncmp(argv[num_arg],"-a", 2) !=0) &&
		 (strncmp(argv[num_arg],"-f", 2) !=0))
	      {
		error=1;
		num_arg++;
		continue;
		//		erreur();
		//		exit(1);
	      }  


	  } // fin while (num_arg < argc)
	
	if (error == 1 )
	  {
	    erreur();
	    exit(1);
	  }
		  
      main_lecture(ficclone, ficancre);
      } // fin Cas lecture
    else
      {
      //-----------------Cas ou le nombre d'arguments est incorrect
	// on regarde si l'un est egal a l'option -f pour ecrire
	// le message d'erreur en francais

	while (num_arg < argc)
	  {    
	    if (strncmp(argv[num_arg],"-f", 2)==0)
		{
		  french=1;
                  break;
		}
	    num_arg++;
	  } // fin du while (num_arg < argc)

      erreur();
      exit(1);
      }  // fin du cas  ou le nombre d'arguments est incorrect
    }
return(0);
}// ----------FIN DU MAIN -------------------------------------
